#ifndef _FTRX_H
#define _FTRX_H

typedef unsigned int     DWORD;
typedef unsigned short   WORD;
typedef unsigned char    BYTE;

#define PIN_NONE        0x00 //̬
#define PIN_USER        0x01 //û̬
#define PIN_ADMIN       0x02 //̬

#define LED_OFF			0x00 //
#define LED_ON			0x01 //
#define LED_BLINK		0x02 //

#define MODE_ENCODE      0   //
#define MODE_DECODE      1   //

#define FILE_DATA                 1 //ͨļ
#define FILE_PRIKEY_RSA           2 //RSA˽Կļ
#define FILE_PRIKEY_ECCSM2        3 //ECCSM2˽Կļ
#define FILE_KEY                  4 //SM43DESԿļ
#define FILE_EXE                  5 //ִļ

//ͨ
#define ERR_SUCCESS           0x9000  //ɹ
#define ERR_INVALID_INS       0x6C00  //ЧINS
#define ERR_INVALID_P1        0x6C01  //ЧP1
#define ERR_INVALID_P2        0x6C02  //ЧP2
#define ERR_INVALID_LEN       0x6C03  //ЧLEN
#define ERR_INVALID_PARAM     0x6C04  //ЧĲ(:еһЩ)
#define ERR_FAILED            0x6C05  //ʧ

//д
#define ERR_READ_ERR          0x6B00  //ݴ
#define ERR_WRITE_ERR         0x6B01  //дݴ

//ļϵͳ
#define ERR_FILE_EXIST        0x6A82  //ļѴ
#define ERR_FILE_NOTFOUND     0x6A83  //ļ
#define ERR_FILE_CFILE_ERR    0x6A86  //ļʧ
#define ERR_FILE_READ_ERR     0x6A87  //ļʧ
#define ERR_FILE_WRITE_ERR    0x6A88  //дļʧ
#define ERR_FILE_DFILE_ERR    0x6A89  //ɾļʧ
#define ERR_FILE_CDIR_ERR     0x6A8A  //ļʧ
#define ERR_FILE_DDIR_ERR     0x6A8B  //ɾļʧ

//Ȩ
#define ERR_NOT_INITED        0x6980  //δʼ
#define ERR_ALREADY_INITED    0x6981  //ѳʼ
#define ERR_ADMINPIN_NOTCHECK 0x6982  //ԱPINûУ
#define ERR_USERPIN_NOTCHECK  0x6983  //ûPINûУ
#define ERR_PIN_BLOCKED       0x6984  //PINѱ
#define ERR_RUN_LIMITED       0x6985  //(:˽Կ㡢)

//Ϣ
typedef struct
{	
	unsigned short  m_Ver;               //COS汾,:0x0201,ʾ2.01 
	unsigned short  m_Type;              //Ӳ: 0xFFʾ׼, 0x00ʾʱ, 0x02ʾ׼U   
	unsigned char   m_BirthDay[8];       //
	unsigned long   m_Agent;             //̱,:Ĭϵ0x00000000
	unsigned long   m_PID;               //ƷID
	unsigned long   m_UserID;            //ûID
	unsigned char   m_HID[8];            //8ֽڵӲID
	unsigned long   m_IsMother;          //ĸ־: 0x01ʾĸ, 0x00ʾĸ     
	
} DONGLE_INFO;

//ļȨṹ
typedef struct
{
	unsigned short  m_Read_Priv;      //Ȩ: 0ΪСȨ  1ΪСûȨ  2ΪСԱȨ
	unsigned short  m_WritePriv;      //дȨ: 0ΪСȨ  1ΪСûȨ  2ΪСԱȨ

} DATA_LIC;

//ļݽṹ
typedef struct
{
	unsigned long   m_Size;      //ļ
	DATA_LIC        m_Lic;       //Ȩ

} DATA_FILE_ATTR;

//˽ԿļȨṹ
typedef struct
{
	long           m_Count;      //ɵ: 0xFFFFFFFFʾ, ݼ0ʾѲɵ
	unsigned char  m_Priv;       //Ȩ: 0ΪСȨ  1ΪСûȨ  2ΪСԱȨ
	unsigned char  m_IsDecOnRAM; //Ƿڴеݼ: 1Ϊڴеݼ    0ΪFLASHеݼ   
	unsigned char  m_IsReset;    //û̬úǷԶص̬: 1Ϊص̬ (Ա̬ܴ)
	unsigned char  m_Reserve;    //,4ֽڶ

} PRIKEY_LIC;

//ԿļȨṹ
typedef struct
{
	unsigned long  m_Priv_Enc;   //ܵȨ: 0ΪСȨ  1ΪСûȨ  2ΪСԱȨ

} KEY_LIC;

//SM2ECCRSA˽Կļݽṹ
typedef struct
{
	unsigned short  m_Type;       //:ECC˽Կ  RSA˽Կ
	unsigned short  m_Size;       //ݳ:rsa˵1024λ2048λ, ecc˵192λ256λ, SM2˵256λ
	PRIKEY_LIC      m_Lic;        //Ȩ

} PRIKEY_FILE_ATTR;

//SM4TDESԿļݽṹ
typedef struct
{
	unsigned long  m_Size;       //Կݳ,16
	KEY_LIC     m_Lic;           //Ȩ

} KEY_FILE_ATTR;

//ⲿRSAԿʽ(1024,2048)
typedef struct {
	unsigned int  bits;                   // length in bits of modulus
	unsigned int  modulus;                // modulus
	unsigned char exponent[256];          // public exponent
} RSA_PUBLIC_KEY;
	
//ⲿRSA˽Կʽ(1024,2048)
typedef struct {
	unsigned int  bits;                   // length in bits of modulus
	unsigned int  modulus;                // modulus
	unsigned char publicExponent[256];    // public exponent
	unsigned char exponent[256];          // private exponent
} RSA_PRIVATE_KEY;

//ⲿECC\SM2Կʽ
typedef struct {
	unsigned int bits;
	unsigned int XCoordinate[8];
	unsigned int YCoordinate[8];
}ECCSM2_PUBLIC_KEY;

//ⲿECCSM2˽Կʽ
typedef struct {
	unsigned int bits;
	unsigned int PrivateKey[8];
} ECCSM2_PRIVATE_KEY;

//ECCSM2˽ԿԸʽ
typedef struct {
    ECCSM2_PRIVATE_KEY Prikey;
	ECCSM2_PUBLIC_KEY  Pubkey;
} ECCSM2_KEY_PAIR;

//=======================================================
//ļ
extern WORD  create_file(WORD type, WORD  fileid, BYTE* pattr, int len_attr);
//ȡļ,fileid=0xFFFFʱʾȡ8K
extern WORD  read_file(WORD fileid, WORD offset, WORD len, BYTE* pbuf);
//дļ
extern WORD  write_file(WORD type, WORD fileid, WORD offset, WORD len, BYTE* pbuf);
//ɾļ
extern WORD  delete_file(WORD type, WORD fileid);
//ȡKEYϢ
extern WORD  get_keyinfo(DONGLE_INFO * pKI);
//ȡǰPINȨ״̬
extern WORD  get_pinstate(DWORD * pState);
//LEDƵĿ
extern WORD  led_control(BYTE flag);
//ȡ
extern WORD  get_random(BYTE* pbuf, BYTE len);
//ȡϵʱ,λms,100ms
extern WORD  get_tickcount(DWORD * pCount);
//ȡʵʱӵʱ
extern WORD  get_realtime(DWORD * pTime);
//ȡʱĵʱ
extern WORD  get_expiretime(DWORD * pTime);
//ڴ(32ֽڳ)
extern WORD  get_sharememory(BYTE * pbuf);
//дڴ(32ֽڳ)
extern WORD  set_sharememory(BYTE * pbuf);
//rsa˽Կ
extern WORD  rsa_genkey(WORD fileid, RSA_PRIVATE_KEY * pRPK);
//rsa˽Կӽ
extern WORD  rsa_pri(WORD fileid, BYTE * pIn, WORD len, BYTE * pOut, WORD * plen_Out, WORD mode);
//rsaԿӽ
extern WORD  rsa_pub(BYTE * pIn, WORD len, RSA_PUBLIC_KEY * pPub, BYTE * pOut, WORD * plen_Out, WORD mode);
//ecc˽Կ
extern WORD  ecc_genkey(WORD fileid, ECCSM2_KEY_PAIR * pEKP);
//ecc˽Կӽ
extern WORD  ecc_sign(WORD fileid, BYTE * pIn, WORD len, BYTE * pOut, WORD * plen_Out);
//eccԿӽ
extern WORD  ecc_verify(ECCSM2_PUBLIC_KEY * pEPK, BYTE * pHash, WORD len_Hash, BYTE * pSign);
//sm2˽Կ
extern WORD  sm2_genkey(WORD fileid, ECCSM2_KEY_PAIR * pEKP);
//sm2˽Կӽ
extern WORD  sm2_sign(WORD fileid, BYTE * pIn, WORD len, BYTE * pOut, WORD * plen_Out);
//sm2Կӽ
extern WORD  sm2_verify(ECCSM2_PUBLIC_KEY * pEPK, BYTE * pHash, WORD len_Hash, BYTE * pSign);
//TDESӽ
extern WORD  tdes(BYTE * pdata ,int len, int mode, WORD fileid);
//SM4ӽ
extern WORD  sm4(BYTE * pdata ,int len, int mode, WORD fileid);
//sha1hash
extern WORD  sha1(BYTE * pdata ,int len, BYTE * phash);
//sm3hash
extern WORD  sm3(BYTE * pdata ,int len, BYTE * phash);
//seed
extern WORD  seed(BYTE * pseed ,int len, BYTE * presult);

#endif
